/* $Id: altq_cbq.h,v 1.1 1998/06/08 09:56:47 kjc Exp kjc $ */
/*
 * Copyright (C) 1997, 1998
 *	Sony Computer Science Laboratory Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY SONY CSL AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL SONY CSL OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */


#define CBQ_MAXCLASS		64

/* class flags shoud be same as class flags in rm_class.h */
#define CBQCLF_RED		0x0001	/* use RED */
#define CBQCLF_ECN		0x0002  /* use RED/ECN */

/* class flags only for root class */
#define CBQCLF_WRR		0x0100	/* weighted-round robin */
#define CBQCLF_EFFICIENT	0x0200  /* work-conserving */

/* class flags for special classes */
#define CBQCLF_ROOTCLASS	0x1000	/* root class */
#define CBQCLF_DEFCLASS		0x2000	/* default class */
#define CBQCLF_CTLCLASS		0x4000	/* control class */
#define CBQCLF_CLASSMASK	0xf000	/* class mask */

extern int cbq_enable(void);
extern int cbq_disable(void);
extern int cbq_ifinit(int, int);
extern struct rm_class *cbq_class_create(char *, char *, int,
					 int, int, int, int, int, int, int);
extern void cbq_class_delete(struct rm_class *);
extern struct rm_class *cbq_class_find(char *);
extern int cbq_status(int);

extern int probe_open(char *, char *, int, int);
extern int probe_close(void);
extern int probe_send(void);

extern int SetCBQ(struct cmdargs const *);
extern int ReportCBQStatus(struct cmdargs const *);
