/* $Id: altq_ppp.h,v 1.1 1998/06/08 09:56:47 kjc Exp kjc $ */
/*
 * Copyright (C) 1997, 1998
 *	Sony Computer Science Laboratory Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY SONY CSL AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL SONY CSL OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/* per interface altq structure */
struct altq {
	int (*altq_enqueue)(struct mbuf *);
	struct mbuf *(*altq_dequeue)(void);
	int (*altq_account)(struct mbuf *);
	int altq_type;		/* discipline type */
	int altq_flags;		/* status */
	int altq_mtu;
};

/* if_altqtype */
#define ALTQT_NONE	0	/* reserved */
#define ALTQT_CBQ	1	/* cbq */

/* if_altqflags */
#define ALTQF_ENABLE	 0x02	/* altq is in use */
#define ALTQF_ACCOUNTING 0x04	/* altq accounting is enabled */

#define ALTQ_IS_ON()	(altqp->altq_flags & ALTQF_ENABLE)

extern struct altq *altqp;

/*
 * for ppp mbuf structure
 */
#define m_freem(m)	mbfree((m))
#define m_nextpkt	pnext
#define	m_pktlen(m)	plength((m))
#define	mtod(m,t)	((t)MBUF_CTOP(m))

/*
 * for timeout/untimeout
 */
/* dummy callout_handle structure */
typedef void *	callout_handle_t;
#define CALLOUT_HANDLE_INIT(h)	{ memset((h),0,sizeof(*h)); }
#define TIMEOUT(f,a,t,h)	{ StopTimer(&(h));	\
				  (h).func = (f);	\
				  (h).arg = (a);	\
				  (h).load = (t);	\
				  StartTimer(&(h)); }
#define UNTIMEOUT(f,a,h)	StopTimer(&(h))

#define microtime(t)	gettimeofday((t),NULL)
/*
 * for ALTQ
 */
#define IF_NAMESIZE	16
#define CL_NAMESIZE	16

#if defined(ALTQ_DEBUG) && (ALTQ_DEBUG != 0)
#include <assert.h>
#define	ASSERT(e)	assert(e)
#else
#undef ALTQ_DEBUG
#define	ASSERT(e)	((void)0)
#endif

extern int altq_debug;

void altq_assert __P((const char *, int, const char *));

extern int altq_attach(int (*)(struct mbuf *),
		       struct mbuf *(*)(void),
		       int (*)(struct mbuf *),
		       int);
extern int altq_detach(int);
extern int altq_enable(int);
extern int altq_disable(int);

